const St = imports.gi.St;
const Main = imports.ui.main;
const Mainloop = imports.mainloop;
const Lang = imports.lang;

// update interval increased to 5 seconds. 
// This doesn't solve the 1st problem at all
// (the 3ms timer had debugging-purpose, and I forgot it in the code. I'm sorry)
// but I haven't found documentation about GnomeDesktop.WallClock (as Giovanni
// suggested).
const UPDATE_INTERVAL = 5000;

var hours_list = [
  /* I18N: %0 will be replaced with the preceding hour, %1 with
   * the comming hour
   * thanks to the XFCE project for this */
  "%0 o'clock",
  "five past %0",
  "ten past %0",
  "quarter past %0",
  "twenty past %0",
  "twenty five past %0",
  "half past %0",
  "twenty five to %1",
  "twenty to %1",
  "quarter to %1",
  "ten to %1",
  "five to %1",
  "%1 o'clock"
  ];
  
var hour_names = [
  "twelve",
  "one",
  "two",
  "three",
  "four",
  "five",
  "six",
  "seven",
  "eight",
  "nine",
  "ten",
  "eleven",
]

function FuzzyClock() {
    this._init();
}

FuzzyClock.prototype = {
    _init: function() {
        this.date_menu = Main.panel._dateMenu;
        this.orig_clock = this.date_menu._clock;
        this.fuzzy_clock = new St.Label();
    },

    Run: function() {
        this.run = true;
        this.on_timeout();
        Mainloop.timeout_add(UPDATE_INTERVAL, Lang.bind(this, this.on_timeout));
    },

    FuzzyHour: function() {
        let now = new Date();
        hours = now.getHours();
        return hours_list[Math.round(now.getMinutes() / 5)]
            .replace("%0", hour_names[hours >= 12 ? hours - 12 : hours])
            .replace("%1", hour_names[hours >= 12 ? hours - 12 + 1 : hours + 1]) ;
    },

    on_timeout: function() {
        this.fuzzy_clock.set_text(this.FuzzyHour());
        
        // I made a mistake in the 1st relase. Returning 'this.run' fixes the
        // problem related to the 'disable' function.
        return this.run;
    },

    enable: function() {
        this.date_menu.actor.remove_actor(this.orig_clock);
        this.date_menu.actor.add_actor(this.fuzzy_clock);

        this.Run();
    },

    disable: function() {
        this.run = false;

        this.date_menu.actor.remove_actor(this.fuzzy_clock);
        this.date_menu.actor.add_actor(this.orig_clock);
    }
}

function init() {
    return new FuzzyClock();
}
